This repository is not used anymore. Please visit [firmware-selector-openwrt-org](https://github.com/openwrt/firmware-selector-openwrt-org/) instead.

# OpenWrt Firmware Selector


A simple OpenWrt firmware selector using autocompletion. Uses plain
HTML/CSS/JavaScript. Checkout the [Demo](https://firmware-selector.openwrt.org).

![image](misc/screenshot.png)

## Quick Run

* Download the sources and change the working directory
* Start webserver (e.g. `python3 -m http.server`)
* Go to [http://localhost:8000/www/](http://localhost:8000/www/) in your web browser

Configure with [config.js](www/config.js).

## Installation

Place the `www/` folder somewhere web accessible. Then use the `collect.py` script to collect all the `profiles.json` files a OpenWrt build has generated. The data will be written to `www/data/` and `www/config.json` will be updated:

Scrape from a web site:
```
./misc/collect.py https://downloads.openwrt.org  www/
```
or via rsync (faster):
```
./misc/collect.py rsync://downloads.openwrt.org/downloads  www/
```
or scan a local OpenWrt build folder:
```
./misc/collect.py ~/openwrt/bin  www/
```

This should do it!

Further arguments for `collect.py`:

* `--formatted`: Output formatted JSON data.
* `--version-pattern <VERSION_PATTERN>`: Only handle versions that match a regular expression.
* `--insert-latest-release`: Insert an artificial release called "latest" that contains the latest image for every device.
* `--latest-release-pattern <VERSION_PATTERN>`: Only handle versions that match a regular expression.

Notes about `config.js`

* `image_url`: Download location of the actual images.
* `info_url`: Link template to some information page.

Allowed variables in `info_url`: `{id}`, `{target}`, `{version}`, `{title}`.

### Generate OpenWrt JSON

The collect.py script merges data from `profile.json` files generated by OpenWrt. To enable generation, go to the build settings (`make menuconfig`):
`Global build settings  ---> [*] Create JSON info files per build image`.

If the option is not available (OpenWrt 18.06 or 19.07.3), apply commit [openwrt/openwrt@881ed09](https://github.com/openwrt/openwrt/commit/881ed09ee6e23f6c224184bb7493253c4624fb9f).

## Attended SysUpgrade (ASU)

[ASU](https://github.com/openwrt/asu) is a build server that builds OpenWrt images with a given list of packages on request. The firmware-selector can be used as an interface to send these requests and to download the images when finished.

### UCI-Defaults

The Firmware Selector allows to define a script to be placed in the `/etc/uci-defaults/` folder of the OpenWrt image. These scripts are executed once on the first reboot and then deleted. See the [OpenWrt documentation](https://openwrt.org/docs/guide-developer/uci-defaults) on this topic.

## Translations

Visit [weblate.org](https://hosted.weblate.org/projects/openwrt/firmware-wizard/) to contribute new translations or to improve them.

## Similar Projects

- [Gluon Firmware Selector](https://github.com/freifunk-darmstadt/gluon-firmware-selector): For [Gluon](https://github.com/freifunk-gluon/) images, now with pictures.
- [Freifunk Hennef Firmware Downloader](https://github.com/Freifunk-Hennef/ffhef-fw-dl): Similar to the project above, but PHP based.
- [LibreMesh Chef](https://github.com/libremesh/chef/): Allows to select configurations.
- [GSoC Firmware Selector](https://github.com/sudhanshu16/openwrt-firmware-selector/): Result of the GSoC
- [FFB Firmware Selector](https://github.com/freifunk-bielefeld/firmware-selector): Build for Freifunk Bielefeld
